//		Copyright (c) 1988-93 by Abraxas Software.

//		This file provides EXAMPLE rules for most
//		of the declaration variables in CodeCheck.


#include <check.cch>

int	k, flags;

if ( dcl_3dots )
	warn( 3000, "The ellipsis notation is new with ANSI C." );

if ( dcl_abstract )
	if ( dcl_parameter )
		warn( 3001, "A name for this parameter will help readability." );

if ( dcl_all_upper )
	warn( 3002, "ALL UPPERCASE identifiers should be reserved for macro names." );

if ( dcl_ambig )
	if ( dcl_global )
		warn( 3003, "Identifier %s matches another on the first 6 characters.", dcl_name() );

if ( dcl_array_size > 32767 )
	warn( 3004, "Be sure to use long integers for indexing this baby." );

if ( dcl_auto_init )
	warn( 3005, "Initializing automatic variables is not portable." );

if ( dcl_base == ENUM_TYPE )
	warn( 3006, "Enumerated variables are not portable to older compilers." );

if ( dcl_bitfield )
	{
	warn( 3007, "Bitfields may present some portability problems." );
	if ( dcl_bitfield_size > 8 )
		warn( 3008, "Bitfield of size > 8" );
	if ( dcl_bitfield_anon )
		warn( 3009, "Some compilers do not like anonymous bitfields." );
	}

if ( dcl_conflict )
	warn( 3010, "%s was declared differently in file %s, line %d.",
			dcl_name(), conflict_file(), conflict_line );

if ( dcl_cv_modifier )
	warn( 3011, "This use of const/volatile is illegal in ANSI C." );

if ( dcl_definition )
	if ( dcl_function || dcl_typedef )
		if ( ! dcl_first_upper )
			warn( 3012, "Function and typedef names should start with an uppercase letter." );

if ( dcl_empty )
	if ( ! dcl_tag_def )
		warn( 3013, "This empty declarator is not allowed in ANSI C." );

if ( dcl_enum_hidden )
	warn( 3014, "The declarator %s hides an enumerated constant.", dcl_name() );

if ( dcl_extern )
	if ( dcl_initializer )
		warn( 3015, "NEVER initialize an explicitly extern variable." );

if ( dcl_extern_ambig )
	warn( 3016, "Declarator %s will be confused with another external name by older linkers.",
			dcl_name() );

if ( dcl_hidden )
	warn( 3017, "This declaration of %s hides another.", dcl_name() );

if ( dcl_Hungarian )
	warn( 3018, "Use underscores instead of Hungarian spelling." );

if ( dcl_ident_length > 31 )
	warn( 3019, "ANSI C uses only the first 31 letters of identifiers." );

if ( dcl_init_arith )
	warn( 3020, "Initializer arithmetic may not be portable." );

if ( dcl_label_overload )
	warn( 3021, "Declarator %s is also a label in this function.", dcl_name() );

if ( dcl_local )
	{
	if ( dcl_any_upper )
		warn( 3022, "Spell local variables without capital letters." );
	if ( dcl_typedef )
		warn( 3023, "Typedef names should always have file scope." );
	if ( (dcl_ident_length < 3) && (! dcl_simple) )
		warn( 3024, "Give this variable a longer, more explanatory name." );
	}

if ( dcl_long_float )
	warn( 3025, "The long float type is not portable to ANSI C." );

if ( dcl_need_3dots )
	warn( 3026, "The trailing comma must be followed by 3 dots in ANSI C." );

if ( dcl_no_specifier )
	{
	if ( dcl_function )
		warn( 3027, "This function needs an explicit return type." );
	else
		warn( 3028, "This variable needs an explicit type." );
	}

if ( dcl_not_declared )
	warn( 3029, "A parameter of this function needs an explicit declaration." );

if ( dcl_oldstyle )
	warn( 3030, "This is an old-style function declarator." );

if ( dcl_parm_count > 5 )
	warn( 3031, "A maximum of 5 parameters is recommended." );

if ( dcl_parm_hidden )
	warn( 3032, "This declarator hides a function parameter." );

if ( dcl_variable || dcl_function )
	{
	k = 0;
	while ( k <= dcl_levels )
		if ( dcl_level_flags(k++) & BASED_FLAG )
			warn( 3033, "Based pointers are peculiar to Microsoft C." );
	}

if ( dcl_static )
	if ( dcl_local && dcl_extern )
		warn( 3034, "The \"static\" specifier here is illegal in ANSI C." );

if ( dcl_typedef_dup )
	warn( 3035, "Duplicated type definitions are not portable." );

if ( dcl_underscore )
	if ( lin_source && dcl_definition )
		warn( 3036, "Lead underscores should be reserved for system software." );

if ( dcl_union_bits )
	warn( 3037, "Bitfields in unions are not portable." );

if ( dcl_union_init )
	warn( 3038, "Union initializers are not portable." );

if ( dcl_zero_array )
	warn( 3039, "ANSI C does not allow zero dimension arrays." );

if ( dcl_no_prototype )
	warn( 3040, "Function %s has no prototype in scope.", dcl_name() );
