/*	declare.cc
	Copyright (c) 1992-94 by Abraxas Software. All rights reserved.
==============================================================================
	Purpose:	Interprets C declarations in "English".
	Author:		Loren Cobb.
	Revision:	3 December 1992.
	Format:		Monospaced font with 4 spaces/tab.
==============================================================================

Abstract:

	These CodeCheck rules interpret each C or C++ global variable and
	function declaration in something close to ordinary English. For
	example, the declaration
	
	short (*const foo)(void)[100];
	
	will be rendered as
	
	foo: constant pointer to function returning array of short.

==============================================================================
*/

#include <check.cch>

int		k, flags;

if ( mod_begin )
	printf( "\nGlobal variables and functions for module %s:\n\n",
			mod_name() );

if ( dcl_global )
	{
	printf( "%15s: ", dcl_name() );
	k = 0;
	while ( k <= dcl_levels )
		{
		flags = dcl_level_flags(k);
		if ( flags & CONST_FLAG )
			printf( "constant " );
		if ( flags & VOLATILE_FLAG )
			printf( "volatile " );
		if ( flags & NEAR_FLAG )
			printf( "near " );
		if ( flags & FAR_FLAG )
			printf( "far " );
		if ( flags & HUGE_FLAG )
			printf( "huge " );
		if ( flags & EXPORT_FLAG )
			printf( "export " );
		if ( flags & BASED_FLAG )
			printf( "based " );
		switch ( dcl_level(k) )
			{
		case ARRAY:
			printf( "array of " );
			break;
		case POINTER:
			printf( "pointer to " );
			break;
		case REFERENCE:
			printf( "reference to " );
			break;
		case FUNCTION:
			printf( "function returning " );
			break;
		case SIMPLE:
			break;
		default:
			printf( " << level = %d ?? >> ", dcl_level(k) );
			}
		k++;
		}
	printf( "%s.\n", dcl_base_name() );
	}

if ( mod_end )
	printf( "\n" );
