/*	Copyright (c) 1988-94 by Abraxas Software.
 *
 *	This is a collection of CodeCheck rules for
 *	portability to the Sun C++ 2.1 compiler.
 */


#include	<check.cch>

int		k, flags, non_ansi_modifier;

if ( prj_begin )
	non_ansi_modifier = ~(CONST_FLAG + VOLATILE_FLAG);

if ( lex_str_concat )
	warn( 7007, "Implicit string concatenation will not port." );

if ( lex_wide )
	warn( 7009, "Wide characters and strings will not port." );

if ( pp_error )
	warn( 7010, "The #error preprocessor directive will not port." );

if ( pp_paste )
	warn( 7011, "The ## (paste) preprocessor operator will not port." );

if ( pp_pragma )
	warn( 7012, "#pragma directives may not port." );	

if ( pp_stringize )
	warn( 7013, "The # (stringize) preprocessor operator will not port." );

if ( pp_unknown) 
	warn( 7014, "This preprocessor directive will not port." );

if ( pp_white_before )
	warn( 7015, "The # character cannot be indented." );

if ( dcl_global || dcl_static || dcl_local )
	{
	k = 0;
	while ( k <= dcl_levels )
		{
		flags = dcl_level_flags(k++);
		/*
			We check for nonstandard type modifiers this
			way (rather than use the keyword() function)
			because they are spelled in different ways,
			e.g. near, _near, __near.
		*/
		if ( flags & non_ansi_modifier )
			{
			if ( flags & NEAR_FLAG )
				warn( 7026, "The \"near\" modifier will not port." );
			if ( flags & FAR_FLAG )
				warn( 7026, "The \"far\" modifier will not port." );
			if ( flags & HUGE_FLAG )
				warn( 7026, "The \"huge\" modifier will not port." );
			if ( flags & EXPORT_FLAG )
				warn( 7026, "The \"export\" modifier will not port." );
			if ( flags & BASED_FLAG )
				warn( 7026, "The \"based\" modifier will not port." );
			if ( flags & SEGMENT_FLAG )
				warn( 7026, "The \"segment\" modifier will not port." );
			}
		}
	}

if ( lex_nested_comment )
	warn( 7027, "Nested comments will not port." );
