/*
***************************************************************************
*                                                                         *
* FILE NAME:	dcl.cc                                                    *
* COPYRIGHT (C) 1994 BY ABRAXAS SOFTWARE. ALL RIGHTS RESERVED.            *
* AUTHOR:	Shuming Tan                     July 21, 1994             *
* PURPOSE:	This a CodeCheck rule file used to test the predefined    *
*               variables in dcl_ group.                                  *
*                                                                         *
***************************************************************************
*/

/* declare the macro to be declared as a variable */
#define __MY_MACRO__  __my_macro__

/* define simple variables */
static int __MY_MACRO__;  /* dcl_underscore, dcl_count, dcl_all_upper, dcl_any_upper */
short Sint1, Sint2;       /* dcl_first_upper, dcl_count */
register char c='0';      /* dcl_auto_init */
long l;
unsigned char uc;         /* dcl_unsigned */
unsigned int ui;
unsigned long ul;
float f;
double d;
long double ld;
signed int lookssimilarmine;  /* dcl_signed */
char lookssimilaryours;       /* dcl_ambig, dcl_extern_ambig */

/* declare a identifier to test dcl_Hungarian, dcl_zero_array */
long* aplHoho[0];

/* test dcl_extern */
extern char* borrowd;

/* define enumerate type */
/* dcl_aggr, dcl_enum, dcl_simple */
enum days {sun=0, mon, tue, wed, thu, fri, sat} weekday;

/* define a union with bitfield */
/* test dcl_member,dcl_bitfield, dcl_union_init, dcl_union_bits, dcl_tag_def */
union overlay
{
  int um1;           
  int um2:8;        
} uniondata={1,10};

/* define a struct with bitfields */
/* test dcl_bitfield_arith, dcl_array_dim(), dcl_array_size */
struct record
{
  char name[30];
  short age:8;
  int :10;
  int height:2+8;
} myprofile;

/* define a class */
/* test dcl_virtual, dcl_access, dcl_pure, dcl_function, dcl_friend, dcl_inline */
class myclass
{
  char* mymemb1;
  int mymemb2;
public:
  myclass(int i=0)
  {
    mymemb1=new char[i];
    mymemb2=i;
  }

  ~myclass()
  {
    delete [] mymemb1;
    mymemb2=0;
  }

  inline int len() {return mymemb2;}

  virtual void show()=0;

  friend int frnd(int);
};

/* define a template */
template <class T,class U> 
T max(T i, T j)
{
  return ((i>j)?i:j);
}

/* test dcl_function_ptr */
void (*fcn_ptr)();

/* test for dcl_typedef, dcl_typedef_dup */
typedef union uniondata typedefs;
typedef struct record typedefs;

/* test dcl_3dots */
int fcn_3dots(...);

/* test dcl_oldstyle, dcl_no_prototype */
int fcn_oldstyle(a)
int a;
{ 
  return a+1;
}

/* test dcl_no_declared */
int fcn_notdcled(int,int);

/* test dcl_parm_hidden, dcl_label_overload */
int
fcn_hidden(int p)
{
  int p;
  label:
  {
    int label;
    return p++;
  }
}