/*
***************************************************************************
*                                                                         *
* FILE NAME:	tag.c                                                     *
* COPYRIGHT (C) 1994 BY ABRAXAS SOFTWARE. ALL RIGHTS RESERVED.            *
* AUTHOR:	Shuming Tan                     July 25, 1994             *
* PURPOSE:	This file contains the C code used to test CodeCheck      *
*               predefined variables in tag_ group accompanying rule      *
*               file tag.cc                                               *
*                                                                         *
***************************************************************************
*/
/* tag_global tag_lines tag_tokens */
/* define a enumerate tag */
/* tag_kind==ENUM_TAG */
enum vehicle 
{SEDAN,WAGON,VAN,BIKE,TRUCK} transport;

/* define a union tag */
/* tag_kind==UNION_TAG */
union overlap
{
  double real;
  long integer;
};

/* define a struct tag */
/* tag_kind==STRUCT_TAG */
struct menu
{
  struct button            /* tag_nested  tag_classes*/
  {
    char label[10];
    int width;
    int height;
  } buttons[5];
  typedef enum keys {PRESSED,RELEASED} KEYSTATE; /* tag_constants */
  typedef struct button BUTTON;                  /* tag_types */
  typedef int INTEGER;
  char title[10];
  void (*func)()[10];
  void init();                                   /* tag_functions */
  void quit();
};

/* define an anonymous C++ class */
/* tag_anonymous tag_kind==CLASS_TAG */
class 
{
   int k;
} noname;

/* define a base class */
class base_1
{
private:                    /* tag_private */
  int bcm11;
  char *bcm12;
protected:                  /* tag_protected */
  long bcm13;
public:                     /* tag_public */
  short bcm14;
  base_1();                 /* tag_constructors tag_has_default */
  ~base_1();                /* tag_has_destr */
  virtual void bcm14(int,char);
  int bcm15();
};

/* define another base class */
class base_2
{
  friend class base_1;   /* tag_friend */
  char bcm21;
  void bcm22;
public:
  base_2(int=0);
  base_2(char='0');
  int bcm23(void);
  virtual void bcm24(void)=0;  /* tag_abstract */
};

/* define a class derived from base_1 and base_2 */
/* tag_bases */
class derived:private base_1,public base_2 
{
private:
    static int dcm1,dcm2;        /* tag_static_mem */
public:
  derived(int);
  derived(short,short);
  derived(long);
  derived(const derived&);         /* tag_has_copy */
  ~derived();
  static char* dcm3(int);          /* tag_static_fcn */
  static void dcm4();
  friend int frnd1(int);           /* tag_fcn_friends */
  friend void frnd2(void);
  friend char frnd3(short,short);
  int operator+(derived);          /* tag_operators */
  int operator*(derived);
  friend int operator%(derived,derived);
};

/* define a template */
/* tag_template */
template<class K,class V> class map
{
  V tcm1;
  K tcm2;
  static void tcm3(void);
  void tcm4(void);
public:
  map();
  map(const K&,const V&);
  ~map();
  map& operator= (const map&);  /* tag_has_assign */
  V& operator[] (const K&);
};  

/* define a class within a function */
/* tag_local tag_hidden */
void function(void)
{
  class base_1
  {                                                                                                                         
    int a;
    long b;
  } mp;

}